import { ComponentType, CSSProperties } from "react";
import { PassedOptions } from "./types";
import "./style.css";
export interface MarkedInputProps<T, T1> {
    /**
     * Annotated text with markups for mark
     */
    value: string;
    /**
     * Change event
     */
    onChange: (value: string) => void;
    /**
     * Component that used for render markups
     */
    Mark: ComponentType<T>;
    /**
    * Component that used for render overlays such as suggestions, mentions, autocomplete, modal, tooltip and etc.
    */
    Overlay?: ComponentType<T1>;
    /**
     * Prevents from changing the value
     */
    readOnly?: boolean;
    /**
     * Passed options for configure
     */
    children: PassedOptions<T>;
    /**
     * Additional classes
     */
    className?: string;
    /**
     * Additional style
     */
    style?: CSSProperties;
    /**
     * Additional classes for span
     */
    spanClassName?: string;
    /**
     * Additional style for span
     */
    spanStyle?: CSSProperties;
}
export declare const MarkedInput: <T, T1>(props: MarkedInputProps<T, T1>) => JSX.Element;
//# sourceMappingURL=MarkedInput.d.ts.map