import { PLACEHOLDER } from "./constants";
import { ReactElement } from "react";
import type { OptionProps } from "../Option";
import { MarkedInputProps } from "./MarkedInput";
import { Trigger } from "./hooks/useTrigger";
export declare type Mark = {
    annotation: string;
    id: string;
    value: string;
    index: number;
    input: string;
    childIndex: number;
};
export interface OverlayProps {
    style: {
        left: number;
        top: number;
    };
    onSelect: onSelect;
    data: string[];
    word: string;
}
export declare type onSelect = ({ id, value }: {
    id: string;
    value: string;
}) => void;
declare type id = `${string}${PLACEHOLDER.Id}${string}`;
declare type value = `${string}${PLACEHOLDER.Value}${string}`;
export declare type Markup = `${value}${id}` | `${value}`;
export declare type PassedOptions<T> = ReactElement<OptionProps<T>> | ReactElement<OptionProps<T>>[];
export declare type Slice<T> = string | Mark;
export declare type SliceMap<T> = Map<number, Slice<T>>;
export declare type Store = {
    props: MarkedInputProps<any, any>;
    options: OptionProps[];
    sliceMap: SliceMap<any>;
    dispatch: Dispatch;
    trigger: Trigger;
};
export declare type Dispatch = (type: Type, payload: Payload) => void;
export declare enum Type {
    Change = 0,
    Delete = 1
}
export declare type Action = {
    type: Type;
    payload: Payload;
};
export declare type Payload = {
    key: number;
    value?: Slice<any>;
};
export {};
//# sourceMappingURL=types.d.ts.map