import { Markup, OverlayProps } from "./MarkedInput/types";
export interface OptionProps<T = Record<string, any>, T1 = Record<string, any>> {
    /**
     * Template string instead of which the mark is rendered.
     * Must contain placeholders: __value__ and __id__
     * @Example: @[__value__](__id__)
     */
    markup: Markup;
    /**
     * Sequence of symbols for calling the overlay.
     */
    trigger?: string;
    /**
     * Data for a overlay component. By default, it is suggestions.
     */
    data?: string[];
    /**
     * Function to initialize overlay props to your requirements.
     * If missing then passed overlay props directly.
     */
    initOverlay?: (props: OverlayProps) => T1;
    /**
     * Function to initialize props for the mark component. Gets arguments from found markup
     */
    initializer: (value: string, id: string) => T;
}
/**
 * Used for configure a MarkedInput
 */
export declare const Option: <T>(props: OptionProps<T, Record<string, any>>) => null;
//# sourceMappingURL=Option.d.ts.map